namespace TLS.Net.NativeAPI.BIO
{
    public enum BioType
    {
        BIO_TYPE_DESCRIPTOR = 0x0100, /* socket, fd, connect or accept */
        BIO_TYPE_FILTER = 0x0200,
        BIO_TYPE_SOURCE_SINK = 0x0400,
        BIO_TYPE_NONE = 0,
        BIO_TYPE_MEM = (1 | BIO_TYPE_SOURCE_SINK),
        BIO_TYPE_FILE = (2 | BIO_TYPE_SOURCE_SINK),
        BIO_TYPE_FD = (4 | BIO_TYPE_SOURCE_SINK | BIO_TYPE_DESCRIPTOR),
        BIO_TYPE_SOCKET = (5 | BIO_TYPE_SOURCE_SINK | BIO_TYPE_DESCRIPTOR),
        BIO_TYPE_NULL = (6 | BIO_TYPE_SOURCE_SINK),
        BIO_TYPE_SSL = (7 | BIO_TYPE_FILTER),
        BIO_TYPE_MD = (8 | BIO_TYPE_FILTER),
        BIO_TYPE_BUFFER = (9 | BIO_TYPE_FILTER),
        BIO_TYPE_CIPHER = (10 | BIO_TYPE_FILTER),
        BIO_TYPE_BASE64 = (11 | BIO_TYPE_FILTER),
        BIO_TYPE_CONNECT = (12 | BIO_TYPE_SOURCE_SINK | BIO_TYPE_DESCRIPTOR),
        BIO_TYPE_ACCEPT = (13 | BIO_TYPE_SOURCE_SINK | BIO_TYPE_DESCRIPTOR),
        BIO_TYPE_NBIO_TEST = (16 | BIO_TYPE_FILTER), /* server proxy BIO */
        BIO_TYPE_NULL_FILTER = (17 | BIO_TYPE_FILTER),
        BIO_TYPE_BIO = (19 | BIO_TYPE_SOURCE_SINK), /* half a BIO pair */
        BIO_TYPE_LINEBUFFER = (20 | BIO_TYPE_FILTER),
        BIO_TYPE_DGRAM = (21 | BIO_TYPE_SOURCE_SINK | BIO_TYPE_DESCRIPTOR),
        BIO_TYPE_ASN1 = (22 | BIO_TYPE_FILTER),
        BIO_TYPE_COMP = (23 | BIO_TYPE_FILTER),
        BIO_TYPE_DGRAM_SCTP = (24 | BIO_TYPE_SOURCE_SINK | BIO_TYPE_DESCRIPTOR),
        BIO_TYPE_START = 128
    }
}